"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MyLocationDirection = MyLocationDirection;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _reactNativeMaps = require("react-native-maps");
var _reactNativeCompassHeading = _interopRequireDefault(require("react-native-compass-heading"));
var _reactNativeGeolocationService = _interopRequireWildcard(require("react-native-geolocation-service"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
// @ts-ignore

// types

function MyLocationDirection(props) {
  const {
    color,
    height = 100,
    width = 100,
    img
  } = props;
  // @ts-ignore
  const [coordinate, setCoordinate] = (0, _react.useState)({
    latitude: 0,
    longitude: 0
  });
  // @ts-ignore
  const [angle, setAngle] = (0, _react.useState)(0);
  (0, _react.useEffect)(() => {
    const degree_update_rate = 3;
    _reactNativeCompassHeading.default.start(degree_update_rate, ({
      heading
    }) => {
      setAngle(heading);
    });
    return () => {
      _reactNativeCompassHeading.default.stop();
    };
  }, []);
  (0, _react.useEffect)(() => {
    const watchId = _reactNativeGeolocationService.default.watchPosition(position => {
      setCoordinate({
        latitude: position.coords.latitude,
        longitude: position.coords.longitude
      });
    }, error => {
      console.log('[MyLocationDirection] error', error);
    }, {
      accuracy: {
        android: 'high',
        ios: 'best'
      },
      enableHighAccuracy: true,
      distanceFilter: 0
    });
    return () => {
      (0, _reactNativeGeolocationService.clearWatch)(watchId);
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNativeMaps.Marker, {
    coordinate: coordinate,
    anchor: _reactNative.Platform.OS === 'ios' ? undefined : {
      x: 0.5,
      y: 0.5
    } // AOS 중심점 안 맞는 문제로 인하여 필요
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Image, {
    source: img,
    style: {
      width,
      height,
      tintColor: color,
      transform: [{
        rotate: `${angle}deg`
      }]
    }
  }));
}
//# sourceMappingURL=index.js.map